=== modified file 'bzrlib/bundle/__init__.py'
--- bzrlib/bundle/__init__.py	2009-11-11 13:19:07 +0000
+++ bzrlib/bundle/__init__.py	2009-11-28 00:48:03 +0000
@@ -55,7 +55,7 @@
 
 def read_mergeable_from_transport(transport, filename, _do_directive=True):
     def get_bundle(transport):
-        return transport.get_bytes(filename), transport
+        return StringIO(transport.get_bytes(filename)), transport
 
     def redirected_transport(transport, exception, redirection_notice):
         note(redirection_notice)
@@ -66,7 +66,7 @@
         return get_transport(url)
 
     try:
-        bytes, transport = do_catching_redirections(get_bundle, transport,
+        bytef, transport = do_catching_redirections(get_bundle, transport,
                                                     redirected_transport)
     except errors.TooManyRedirections:
         raise errors.NotABundle(transport.clone(filename).base)
@@ -86,8 +86,8 @@
 
     if _do_directive:
         try:
-            return MergeDirective.from_lines(bytes.splitlines(True)), transport
+            return MergeDirective.from_lines(bytef), transport
         except errors.NotAMergeDirective:
-            pass
+            bytef.seek(0)
 
-    return _serializer.read_bundle(StringIO(bytes)), transport
+    return _serializer.read_bundle(bytef), transport

=== modified file 'bzrlib/merge_directive.py'
--- bzrlib/merge_directive.py	2009-10-29 05:49:32 +0000
+++ bzrlib/merge_directive.py	2009-11-28 00:48:03 +0000
@@ -371,15 +371,13 @@
         :return: a MergeRequest
         """
         line_iter = iter(lines)
+        firstline = ""
         for line in line_iter:
             if line.startswith('# Bazaar merge directive format '):
-                break
-        else:
-            if len(lines) > 0:
-                raise errors.NotAMergeDirective(lines[0])
-            else:
-                raise errors.NotAMergeDirective('')
-        return _format_registry.get(line[2:].rstrip())._from_lines(line_iter)
+                return _format_registry.get(line[2:].rstrip())._from_lines(
+                    line_iter)
+            firstline = firstline or line.strip()
+        raise errors.NotAMergeDirective(firstline)
 
     @classmethod
     def _from_lines(klass, line_iter):

=== modified file 'bzrlib/tests/blackbox/test_send.py'
--- bzrlib/tests/blackbox/test_send.py	2009-10-02 07:24:29 +0000
+++ bzrlib/tests/blackbox/test_send.py	2009-11-28 00:48:03 +0000
@@ -67,7 +67,7 @@
 
     def get_MD(self, args, cmd=None, wd='branch'):
         out = StringIO(self.run_send(args, cmd=cmd, wd=wd)[0])
-        return merge_directive.MergeDirective.from_lines(out.readlines())
+        return merge_directive.MergeDirective.from_lines(out)
 
     def assertBundleContains(self, revs, args, cmd=None, wd='branch'):
         md = self.get_MD(args, cmd=cmd, wd=wd)
@@ -322,8 +322,7 @@
         out, err = self.run_send(args)
         self.assertEquals(
             'Bundling %d revision(s).\n' % len(revs), err)
-        md = merge_directive.MergeDirective.from_lines(
-                StringIO(out).readlines())
+        md = merge_directive.MergeDirective.from_lines(StringIO(out))
         self.assertEqual('parent', md.base_revision_id)
         br = serializer.read_bundle(StringIO(md.get_raw_bundle()))
         self.assertEqual(set(revs), set(r.revision_id for r in br.revisions))

